# coding: utf-8

"""
    UBIKA WAAP Gateway and Cloud API

    The UBIKA's WAAP management API provides a REST/JSON programming interface. It allows automation and scripting of WAAP administration tasks, such as management of reverse proxies and tunnels. The API documentation is shipped with the product itself. Once the product installed, you can access the documentation on the following URL https://ManagementWAAP:3001/api/v1/doc/  # noqa: E501

    The version of the OpenAPI document: 1.0.9
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubika_waap_api_client.configuration import Configuration


class CreateTunnelMonitor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'enabled': 'bool',
        'backend': 'CreateTunnelMonitorBackend'
    }

    attribute_map = {
        'enabled': 'enabled',
        'backend': 'backend'
    }

    def __init__(self, enabled=None, backend=None, local_vars_configuration=None):  # noqa: E501
        """CreateTunnelMonitor - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._enabled = None
        self._backend = None
        self.discriminator = None

        if enabled is not None:
            self.enabled = enabled
        if backend is not None:
            self.backend = backend

    @property
    def enabled(self):
        """Gets the enabled of this CreateTunnelMonitor.  # noqa: E501


        :return: The enabled of this CreateTunnelMonitor.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this CreateTunnelMonitor.


        :param enabled: The enabled of this CreateTunnelMonitor.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def backend(self):
        """Gets the backend of this CreateTunnelMonitor.  # noqa: E501


        :return: The backend of this CreateTunnelMonitor.  # noqa: E501
        :rtype: CreateTunnelMonitorBackend
        """
        return self._backend

    @backend.setter
    def backend(self, backend):
        """Sets the backend of this CreateTunnelMonitor.


        :param backend: The backend of this CreateTunnelMonitor.  # noqa: E501
        :type: CreateTunnelMonitorBackend
        """

        self._backend = backend

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateTunnelMonitor):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateTunnelMonitor):
            return True

        return self.to_dict() != other.to_dict()
