# coding: utf-8

"""
    UBIKA WAAP Gateway and Cloud API

    The UBIKA's WAAP management API provides a REST/JSON programming interface. It allows automation and scripting of WAAP administration tasks, such as management of reverse proxies and tunnels. The API documentation is shipped with the product itself. Once the product installed, you can access the documentation on the following URL https://ManagementWAAP:3001/api/v1/doc/  # noqa: E501

    The version of the OpenAPI document: 1.0.9
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubika_waap_api_client.configuration import Configuration


class FileUploadSuccessData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'uid': 'str',
        'name': 'str',
        'size': 'int',
        'md5sum': 'str',
        'expire': 'int'
    }

    attribute_map = {
        'uid': 'uid',
        'name': 'name',
        'size': 'size',
        'md5sum': 'md5sum',
        'expire': 'expire'
    }

    def __init__(self, uid=None, name=None, size=None, md5sum=None, expire=None, local_vars_configuration=None):  # noqa: E501
        """FileUploadSuccessData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._uid = None
        self._name = None
        self._size = None
        self._md5sum = None
        self._expire = None
        self.discriminator = None

        if uid is not None:
            self.uid = uid
        if name is not None:
            self.name = name
        if size is not None:
            self.size = size
        if md5sum is not None:
            self.md5sum = md5sum
        if expire is not None:
            self.expire = expire

    @property
    def uid(self):
        """Gets the uid of this FileUploadSuccessData.  # noqa: E501


        :return: The uid of this FileUploadSuccessData.  # noqa: E501
        :rtype: str
        """
        return self._uid

    @uid.setter
    def uid(self, uid):
        """Sets the uid of this FileUploadSuccessData.


        :param uid: The uid of this FileUploadSuccessData.  # noqa: E501
        :type: str
        """

        self._uid = uid

    @property
    def name(self):
        """Gets the name of this FileUploadSuccessData.  # noqa: E501


        :return: The name of this FileUploadSuccessData.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FileUploadSuccessData.


        :param name: The name of this FileUploadSuccessData.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def size(self):
        """Gets the size of this FileUploadSuccessData.  # noqa: E501


        :return: The size of this FileUploadSuccessData.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this FileUploadSuccessData.


        :param size: The size of this FileUploadSuccessData.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def md5sum(self):
        """Gets the md5sum of this FileUploadSuccessData.  # noqa: E501


        :return: The md5sum of this FileUploadSuccessData.  # noqa: E501
        :rtype: str
        """
        return self._md5sum

    @md5sum.setter
    def md5sum(self, md5sum):
        """Sets the md5sum of this FileUploadSuccessData.


        :param md5sum: The md5sum of this FileUploadSuccessData.  # noqa: E501
        :type: str
        """

        self._md5sum = md5sum

    @property
    def expire(self):
        """Gets the expire of this FileUploadSuccessData.  # noqa: E501


        :return: The expire of this FileUploadSuccessData.  # noqa: E501
        :rtype: int
        """
        return self._expire

    @expire.setter
    def expire(self, expire):
        """Sets the expire of this FileUploadSuccessData.


        :param expire: The expire of this FileUploadSuccessData.  # noqa: E501
        :type: int
        """

        self._expire = expire

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileUploadSuccessData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FileUploadSuccessData):
            return True

        return self.to_dict() != other.to_dict()
