# coding: utf-8

"""
    UBIKA WAAP Gateway and Cloud API

    The UBIKA's WAAP management API provides a REST/JSON programming interface. It allows automation and scripting of WAAP administration tasks, such as management of reverse proxies and tunnels. The API documentation is shipped with the product itself. Once the product installed, you can access the documentation on the following URL https://ManagementWAAP:3001/api/v1/doc/  # noqa: E501

    The version of the OpenAPI document: 1.0.9
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubika_waap_api_client.configuration import Configuration


class PatchApplianceSuccessDataSsh(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'enable': 'bool',
        'interfaces': 'list[PatchApplianceInterfacesSuccessArray]',
        'port': 'int'
    }

    attribute_map = {
        'enable': 'enable',
        'interfaces': 'interfaces',
        'port': 'port'
    }

    def __init__(self, enable=None, interfaces=None, port=None, local_vars_configuration=None):  # noqa: E501
        """PatchApplianceSuccessDataSsh - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._enable = None
        self._interfaces = None
        self._port = None
        self.discriminator = None

        if enable is not None:
            self.enable = enable
        if interfaces is not None:
            self.interfaces = interfaces
        if port is not None:
            self.port = port

    @property
    def enable(self):
        """Gets the enable of this PatchApplianceSuccessDataSsh.  # noqa: E501


        :return: The enable of this PatchApplianceSuccessDataSsh.  # noqa: E501
        :rtype: bool
        """
        return self._enable

    @enable.setter
    def enable(self, enable):
        """Sets the enable of this PatchApplianceSuccessDataSsh.


        :param enable: The enable of this PatchApplianceSuccessDataSsh.  # noqa: E501
        :type: bool
        """

        self._enable = enable

    @property
    def interfaces(self):
        """Gets the interfaces of this PatchApplianceSuccessDataSsh.  # noqa: E501


        :return: The interfaces of this PatchApplianceSuccessDataSsh.  # noqa: E501
        :rtype: list[PatchApplianceInterfacesSuccessArray]
        """
        return self._interfaces

    @interfaces.setter
    def interfaces(self, interfaces):
        """Sets the interfaces of this PatchApplianceSuccessDataSsh.


        :param interfaces: The interfaces of this PatchApplianceSuccessDataSsh.  # noqa: E501
        :type: list[PatchApplianceInterfacesSuccessArray]
        """

        self._interfaces = interfaces

    @property
    def port(self):
        """Gets the port of this PatchApplianceSuccessDataSsh.  # noqa: E501


        :return: The port of this PatchApplianceSuccessDataSsh.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this PatchApplianceSuccessDataSsh.


        :param port: The port of this PatchApplianceSuccessDataSsh.  # noqa: E501
        :type: int
        """

        self._port = port

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PatchApplianceSuccessDataSsh):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PatchApplianceSuccessDataSsh):
            return True

        return self.to_dict() != other.to_dict()
