# coding: utf-8

"""
    UBIKA WAAP Gateway and Cloud API

    The UBIKA's WAAP management API provides a REST/JSON programming interface. It allows automation and scripting of WAAP administration tasks, such as management of reverse proxies and tunnels. The API documentation is shipped with the product itself. Once the product installed, you can access the documentation on the following URL https://ManagementWAAP:3001/api/v1/doc/  # noqa: E501

    The version of the OpenAPI document: 1.0.9
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from ubika_waap_api_client.configuration import Configuration


class UpdateRequesttimeoutprofile(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'header_timeout': 'str',
        'body_timeout': 'str',
        'header_rate': 'int',
        'body_rate': 'int'
    }

    attribute_map = {
        'name': 'name',
        'header_timeout': 'headerTimeout',
        'body_timeout': 'bodyTimeout',
        'header_rate': 'headerRate',
        'body_rate': 'bodyRate'
    }

    def __init__(self, name=None, header_timeout=None, body_timeout=None, header_rate=None, body_rate=None, local_vars_configuration=None):  # noqa: E501
        """UpdateRequesttimeoutprofile - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._header_timeout = None
        self._body_timeout = None
        self._header_rate = None
        self._body_rate = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if header_timeout is not None:
            self.header_timeout = header_timeout
        if body_timeout is not None:
            self.body_timeout = body_timeout
        if header_rate is not None:
            self.header_rate = header_rate
        if body_rate is not None:
            self.body_rate = body_rate

    @property
    def name(self):
        """Gets the name of this UpdateRequesttimeoutprofile.  # noqa: E501


        :return: The name of this UpdateRequesttimeoutprofile.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UpdateRequesttimeoutprofile.


        :param name: The name of this UpdateRequesttimeoutprofile.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def header_timeout(self):
        """Gets the header_timeout of this UpdateRequesttimeoutprofile.  # noqa: E501


        :return: The header_timeout of this UpdateRequesttimeoutprofile.  # noqa: E501
        :rtype: str
        """
        return self._header_timeout

    @header_timeout.setter
    def header_timeout(self, header_timeout):
        """Sets the header_timeout of this UpdateRequesttimeoutprofile.


        :param header_timeout: The header_timeout of this UpdateRequesttimeoutprofile.  # noqa: E501
        :type: str
        """

        self._header_timeout = header_timeout

    @property
    def body_timeout(self):
        """Gets the body_timeout of this UpdateRequesttimeoutprofile.  # noqa: E501


        :return: The body_timeout of this UpdateRequesttimeoutprofile.  # noqa: E501
        :rtype: str
        """
        return self._body_timeout

    @body_timeout.setter
    def body_timeout(self, body_timeout):
        """Sets the body_timeout of this UpdateRequesttimeoutprofile.


        :param body_timeout: The body_timeout of this UpdateRequesttimeoutprofile.  # noqa: E501
        :type: str
        """

        self._body_timeout = body_timeout

    @property
    def header_rate(self):
        """Gets the header_rate of this UpdateRequesttimeoutprofile.  # noqa: E501


        :return: The header_rate of this UpdateRequesttimeoutprofile.  # noqa: E501
        :rtype: int
        """
        return self._header_rate

    @header_rate.setter
    def header_rate(self, header_rate):
        """Sets the header_rate of this UpdateRequesttimeoutprofile.


        :param header_rate: The header_rate of this UpdateRequesttimeoutprofile.  # noqa: E501
        :type: int
        """

        self._header_rate = header_rate

    @property
    def body_rate(self):
        """Gets the body_rate of this UpdateRequesttimeoutprofile.  # noqa: E501


        :return: The body_rate of this UpdateRequesttimeoutprofile.  # noqa: E501
        :rtype: int
        """
        return self._body_rate

    @body_rate.setter
    def body_rate(self, body_rate):
        """Sets the body_rate of this UpdateRequesttimeoutprofile.


        :param body_rate: The body_rate of this UpdateRequesttimeoutprofile.  # noqa: E501
        :type: int
        """

        self._body_rate = body_rate

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateRequesttimeoutprofile):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateRequesttimeoutprofile):
            return True

        return self.to_dict() != other.to_dict()
